import datetime, os, urllib



def download_backup(backup_url: str, file_path: str):
    urllib.request.urlretrieve(backup_url, file_path)


def create_dirs_and_download(backup_url: str, date: datetime.datetime, base_path: str) -> str:
    year = str(date.year)
    month = str(date.month)
    day = str(date.day)
    
    if not os.path.exists(f"{base_path}/{year}"):
        os.makedirs(f"{base_path}/{year}")

    if not os.path.exists(f"{base_path}/{year}/{month}"):
        os.makedirs(f"{base_path}/{year}/{month}")

    save_path = f"{base_path}/{year}/{month}/{year}_{month}_{day}.tar.gz"

    print(save_path)

    download_backup(backup_url=backup_url, file_path=save_path)

    return f"{year}/{month}/{year}_{month}_{day}.tar.gz"